#!/bin/bash

INTI_PKGS=(slapd ldap-utils)
INTI_EX_CODE=0

for (( i = 0; i < ${#INTI_PKGS[@]}; i=$i+1 )); do
    PKG_OK=$(dpkg-query -W --showformat='${Status}\n' ${INTI_PKGS[${i}]} | grep "install ok installed")
    if [ -z "$PKG_OK" ]; then
        echo "Install missing package ${INTI_PKGS[${i}]} to continue"
        INTI_EX_CODE=1
    fi
done

if [ $INTI_EX_CODE -eq 1 ]; then
    echo "Install missing packages to continue"
else
    echo "All depedencies are installed"
fi

exit $INTI_EX_CODE
